#include "gl.h"

typedef struct BgimageUniforms {
    GLint image;
    GLint opacity;
    GLint premult;
    GLint tiled;
    GLint sizes;
    GLint positions;
} BgimageUniforms;

static inline void
get_uniform_locations_bgimage(int program, BgimageUniforms *ans) {
    ans->image = get_uniform_location(program, "image");
    ans->opacity = get_uniform_location(program, "opacity");
    ans->premult = get_uniform_location(program, "premult");
    ans->tiled = get_uniform_location(program, "tiled");
    ans->sizes = get_uniform_location(program, "sizes");
    ans->positions = get_uniform_location(program, "positions");
}

typedef struct BorderUniforms {
    GLint viewport;
    GLint colors;
    GLint background_opacity;
    GLint tint_opacity;
    GLint tint_premult;
} BorderUniforms;

static inline void
get_uniform_locations_border(int program, BorderUniforms *ans) {
    ans->viewport = get_uniform_location(program, "viewport");
    ans->colors = get_uniform_location(program, "colors");
    ans->background_opacity = get_uniform_location(program, "background_opacity");
    ans->tint_opacity = get_uniform_location(program, "tint_opacity");
    ans->tint_premult = get_uniform_location(program, "tint_premult");
}

typedef struct CellUniforms {
    GLint sprites;
    GLint text_contrast;
    GLint text_gamma_adjustment;
    GLint text_fg_override_threshold;
    GLint draw_bg_bitfield;
    GLint inactive_text_alpha;
    GLint dim_opacity;
} CellUniforms;

static inline void
get_uniform_locations_cell(int program, CellUniforms *ans) {
    ans->sprites = get_uniform_location(program, "sprites");
    ans->text_contrast = get_uniform_location(program, "text_contrast");
    ans->text_gamma_adjustment = get_uniform_location(program, "text_gamma_adjustment");
    ans->text_fg_override_threshold = get_uniform_location(program, "text_fg_override_threshold");
    ans->draw_bg_bitfield = get_uniform_location(program, "draw_bg_bitfield");
    ans->inactive_text_alpha = get_uniform_location(program, "inactive_text_alpha");
    ans->dim_opacity = get_uniform_location(program, "dim_opacity");
}

typedef struct GraphicsUniforms {
    GLint image;
    GLint amask_fg;
    GLint amask_bg_premult;
    GLint inactive_text_alpha;
    GLint src_rect;
    GLint dest_rect;
    GLint viewport;
} GraphicsUniforms;

static inline void
get_uniform_locations_graphics(int program, GraphicsUniforms *ans) {
    ans->image = get_uniform_location(program, "image");
    ans->amask_fg = get_uniform_location(program, "amask_fg");
    ans->amask_bg_premult = get_uniform_location(program, "amask_bg_premult");
    ans->inactive_text_alpha = get_uniform_location(program, "inactive_text_alpha");
    ans->src_rect = get_uniform_location(program, "src_rect");
    ans->dest_rect = get_uniform_location(program, "dest_rect");
    ans->viewport = get_uniform_location(program, "viewport");
}

typedef struct TintUniforms {
    GLint tint_color;
    GLint edges;
} TintUniforms;

static inline void
get_uniform_locations_tint(int program, TintUniforms *ans) {
    ans->tint_color = get_uniform_location(program, "tint_color");
    ans->edges = get_uniform_location(program, "edges");
}
